/***********************************************************************************************************************
 *
 * blueBill Mobile - open source birdwatching
 * ==========================================
 *
 * Copyright (C) 2009, 2010 by Tidalwave s.a.s. (http://www.tidalwave.it)
 * http://bluebill.tidalwave.it/mobile/
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: FactSheet.java,v de87bb2f8007 2010/07/16 16:24:32 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.bluebill.factsheet.bbc;

import it.tidalwave.bluebill.factsheet.Adaptation;
import it.tidalwave.bluebill.factsheet.Biblio;
import it.tidalwave.bluebill.factsheet.Habitat;
import it.tidalwave.mobile.media.Movie;
import it.tidalwave.mobile.media.StillImage;
import javax.annotation.Nonnull;
import java.util.Collection;
import java.util.Map;
import it.tidalwave.util.Id;
import it.tidalwave.util.Key;
import it.tidalwave.semantic.EntityWithProperties;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: $
 *
 **********************************************************************************************************************/
public class FactSheet extends EntityWithProperties<FactSheet>
  {
    public static final Key<String> DC_DESCRIPTION = new Key<String>("http://purl.org/dc/terms/description");
    public static final Key<String> DC_RIGHTS = new Key<String>("http://purl.org/dc/terms/rights");
    public static final Key<EntityWithProperties<?>> DC_PUBLISHER = new Key<EntityWithProperties<?>>("http://purl.org/dc/terms/publisher");
    public static final Key<Collection<Adaptation>> ADAPTATIONS = new Key<Collection<Adaptation>>("http://purl.org/ontology/wo/adaptation");
    public static final Key<Collection<Biblio>> BIBLIOS = new Key<Collection<Biblio>>("urn:biblio");
    public static final Key<Collection<StillImage>> IMAGES = new Key<Collection<StillImage>>("urn:stillImage");
    public static final Key<Collection<Movie>> MOVIES = new Key<Collection<Movie>>("urn:movie");
    public static final Key<Collection<Habitat>> LIVES_IN = new Key<Collection<Habitat>>("http://purl.org/ontology/wo/livesIn");
    
    public static final Key<Object> __BIBLIO = new Key<Object>("urn:biblio");
    public static final Key<Object> __IMAGE = new Key<Object>("urn:stillImage");
    public static final Key<Object> __MOVIE = new Key<Object>("urn:movie");
    public static final Key<Object> __LIVES_IN = new Key<Object>("http://purl.org/ontology/wo/livesIn");

    public FactSheet (final @Nonnull Id id)
      {
        super(id);
      }

    protected FactSheet (final @Nonnull Id id, final @Nonnull Map<Key<?>, Object> map)
      {
        super(id, map);
      }

    @Override @Nonnull
    protected FactSheet clone (final @Nonnull Map<Key<?>, Object> asMap)
      {
        return new FactSheet(getId(), asMap);
      }
  }
