/***********************************************************************************************************************
 *
 * blueBill Mobile - open source birdwatching
 * ==========================================
 *
 * Copyright (C) 2009, 2010 by Tidalwave s.a.s. (http://www.tidalwave.it)
 * http://bluebill.tidalwave.it/mobile/
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: MovieUnmarshaller.java,v de87bb2f8007 2010/07/16 16:24:32 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.bluebill.factsheet.bbc;

import it.tidalwave.mobile.media.Movie;
import javax.annotation.Nonnull;
import java.util.List;
import it.tidalwave.util.As;
import it.tidalwave.util.Id;
import it.tidalwave.util.Key;
import org.openrdf.model.Statement;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: $
 *
 **********************************************************************************************************************/
public class MovieUnmarshaller extends StatementUnmarshallerSupport
  {
    @Nonnull
    public As unmarshal (final @Nonnull List<Statement> statements, final @Nonnull Context context)
      {
        final Id id = findId(statements, context);
        Movie movie = new Movie(id).with(FactSheet.DC_RIGHTS, BbcFactSheetProvider.BBC_SYNDICATION_GUIDELINES);

        for (final Statement statement : statements)
          {
            final String predicate = statement.getPredicate().stringValue();

            if (predicate.startsWith(WoVocabulary.NS_DC))
              {
                final Key<Object> key = new Key<Object>(predicate);
                movie = movie.with(key, deserialize(statement.getObject()));
              }
            else if (!predicate.equals(WoVocabulary.RDF_TYPE.stringValue())
                     && !predicate.equals(WoVocabulary.PO_SUBJECT.stringValue()))
              {
                System.err.println("MOVIE Unused statement: " + statement);
              }
          }

        return movie;
      }
  }
