/***********************************************************************************************************************
 *
 * blueBill Mobile - open source birdwatching
 * ==========================================
 *
 * Copyright (C) 2009, 2010 by Tidalwave s.a.s. (http://www.tidalwave.it)
 * http://bluebill.tidalwave.it/mobile/
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: StatementUnmarshallerSupport.java,v 25f8f565294f 2010/07/12 00:43:16 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.bluebill.factsheet.bbc;

import javax.annotation.Nonnull;
import java.util.List;
import it.tidalwave.util.Id;
import it.tidalwave.semantic.io.spi.StatementUnmarshaller;
import org.openrdf.model.Literal;
import org.openrdf.model.Statement;
import org.openrdf.model.Value;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: $
 *
 **********************************************************************************************************************/
public abstract class StatementUnmarshallerSupport implements StatementUnmarshaller
  {
    @Nonnull
    protected Id findId (final @Nonnull List<Statement> statements, final @Nonnull Context context)
      {
        return new Id(statements.get(0).getSubject().stringValue());
      }

    @Nonnull
    protected Object deserialize (final @Nonnull Value value)
      {
        return (value instanceof Literal) ? value.stringValue() : value;
      }
  }
