/***********************************************************************************************************************
 *
 * blueBill Mobile - open source birdwatching
 * ==========================================
 *
 * Copyright (C) 2009, 2010 by Tidalwave s.a.s. (http://www.tidalwave.it)
 * http://bluebill.tidalwave.it/mobile/
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: WoVocabulary.java,v 7b104dad6889 2010/07/15 22:40:04 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.bluebill.factsheet.bbc;

import it.tidalwave.semantic.Type;
import it.tidalwave.util.Id;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: $
 *
 **********************************************************************************************************************/
public final class WoVocabulary
  {
    public final static String NS_RDF         = "http://www.w3.org/1999/02/22-rdf-syntax-ns#";
    public final static String NS_RDFS        = "http://www.w3.org/2000/01/rdf-schema#";
    public final static String NS_WO          = "http://purl.org/ontology/wo/";
    public final static String NS_DC          = "http://purl.org/dc/terms/";
    public final static String NS_FOAF        = "http://xmlns.com/foaf/0.1/";
    public final static String NS_PO          = "http://purl.org/ontology/po/";

    public final static Type WO_SPECIES       = new Type(NS_WO + "Species");
    public final static Type WO_ADAPTATION    = new Type(NS_WO + "adaptation");
    public final static Type WO_LIVES_IN      = new Type(NS_WO + "livesIn");

    public static final Type RDF_TYPE         = new Type(NS_RDF + "type");

    public static final Type RDFS_LABEL       = new Type(NS_RDFS + "label");

    public static final Id FOAF_IMAGE         = new Id(NS_FOAF + "Image");
    public static final Id FOAF_DEPICTS       = new Id(NS_FOAF + "depicts");
    public static final Id FOAF_THUMBNAIL     = new Id(NS_FOAF + "thumbnail");
    public static final Id FOAF_PRIMARY_TOPIC = new Id(NS_FOAF + "primaryTopic");

    public static final Id PO_SUBJECT         = new Id(NS_PO + "subject");
    public static final Id PO_CLIP            = new Id(NS_PO + "Clip");
    public static final Id PO_EPISODE         = new Id(NS_PO + "Episode");
  }
